"use strict";
const metadata_1 = require('../core/metadata');
require('reflect-metadata');
const pk_decorator_1 = require('./pk.decorator');
function furnishDefaults(meta, model) {
    if (!meta.tableName)
        meta.tableName = model.name;
}
function Model(tableName) {
    var meta;
    if (typeof tableName === 'string')
        meta = { tableName: tableName };
    else if (typeof tableName !== 'undefined')
        meta = tableName;
    return function (model) {
        furnishDefaults(meta, model);
        Reflect.defineMetadata(metadata_1.ModelMetadataSym, meta, model.prototype);
        let props = Reflect.getOwnMetadata(metadata_1.ModelPropertiesSym, model.prototype) || [];
        if (!props.find(propName => propName == 'id')) {
            pk_decorator_1.Pk()(model.prototype, 'id');
            props = Reflect.getOwnMetadata(metadata_1.ModelPropertiesSym, model.prototype);
        }
        Reflect.defineMetadata(metadata_1.ModelPropertiesSym, props, model.prototype);
    };
}
exports.Model = Model;
//# sourceMappingURL=model.decorator.js.map