"use strict";
const metadata_1 = require('../core/metadata');
require('reflect-metadata');
function createRouteDecorator(meta, method) {
    if (typeof meta === 'string')
        meta = { path: meta };
    if (typeof method !== 'undefined') {
        if (meta.method && meta.method != method)
            throw new Error(`Redeclaration of route method: ${meta}`);
        meta.method = method;
    }
    else
        meta.method = meta.method || 'get';
    return function (controller, routeName, routeFn) {
        var routes = Reflect.getOwnMetadata(metadata_1.ControllerRoutesSym, controller) || [];
        routes.push(routeName);
        Reflect.defineMetadata(metadata_1.ControllerRoutesSym, routes, controller);
        Reflect.defineMetadata(metadata_1.RouteMetadataSym, meta, controller, routeName);
    };
}
exports.createRouteDecorator = createRouteDecorator;
function Route(meta) {
    return createRouteDecorator(meta);
}
exports.Route = Route;
//# sourceMappingURL=route.decorator.js.map