/// <reference types="express" />
import * as express from 'express';
import { Injector } from '../core';
import { ServerMetadata } from '../core/metadata';
export declare class Server {
    private _meta;
    constructor(_meta: ServerMetadata);
    private _app;
    readonly app: express.Application;
    private _injector;
    readonly injector: Injector;
    readonly meta: ServerMetadata;
    init(): Promise<void>;
    private ormReflector;
    reflectOrm(): Promise<void>;
    private serviceReflector;
    startServices(): Promise<void>;
    private routerReflector;
    reflectRoutes(): void;
    private httpServer;
    listen(): void;
    private onError(error);
    private onListening();
}
